;further improvement of the limiTED2 512 bytes compo entry 
;production by gerliczer 2009.05.03.
;made in Csabo's Plus4IDE
;upload to strictly 264 series related sites only

	ORG $1001-2
	DW  $1001
	;
	DW $100B,0
	DB $9E,"4109",0,0,0
	;
rorigin	EQU $812	; base address of first displayed line
dest    EQU $2000	; pointer of depacked text data

scroptr	EQU $e5		; first displayed line of above mentioned data
scroidx EQU $e6		; relative index of displayed line from scroptr
srcptrl EQU $e7		; source pointer low byte
srcptrh EQU $e8		; source pointer high byte
incidx1	EQU $e9		; table index for perspective correction
incidx2	EQU $ea		; table index for vertical streching
dstptrl EQU $d9		; destination pointer low byte
dstptrh EQU $da		; destination pointer high byte
tempvar EQU $d8
DELTAX	EQU $e0		; width of destination row
DELTAY	EQU $e1		; width of source row (always 8)
ERROR	EQU $e2		; auxiliary variables for _bresenh_ routine
X0	EQU $e3
Y0	EQU $e4

	JSR $f30b	; screen setup
	DEC $ff0c
	DEC $ff0d
	LDX #0
	LDA #160
loop1	STA $c00,x
	STA $d00,x
	STA $e00,x
	STA $f00,x
	INX
	BNE loop1
	STX $ff19
	;
	STX scroptr	; resetting scroll variables
	STX srcptrl
	STX srcptrh
	;
loop2	LDA textidx,x	; depacking text data
	STX tempvar
	ASL A
	TAY
	JSR byt2dw
	INY
	JSR byt2dw
	LDX tempvar
	INX
	CPX #74
	BNE loop2
	JSR copydat	; duplicate text data
	;
loop3	LDA scroptr	; scrolling starts here
	STA scroidx       
	LDX #0
	STX tempvar
	STX incidx1
	STX incidx2
loop4	TXA		; setting up copy destination
	BNE skip0
	LDA #rorigin&$ff	; initialising with base address
	STA dstptrl
	LDA #rorigin>>8
	STA dstptrh
	JMP skip2
skip0	LDY #39		; calculating next address
	DEX
	LDA perspc_width,x	; with the vertical strech data of LUT
	AND #2
	BNE skip1
	INY
skip1	TYA
	CLC
	ADC dstptrl
	STA dstptrl
	BCC skip2
	INC dstptrh
skip2	LDA #0		; setting up scroll source
	STA srcptrh
	LDA scroidx
	STA srcptrl
	ASL srcptrl
	ROL srcptrh
	ASL srcptrl
	ROL srcptrh
	ASL srcptrl
	ROL srcptrh
	LDA #dest>>8
	CLC
	ADC srcptrh
	STA srcptrh
	;
	JSR bresenh 	; come Mr. Bresenham strech us a bit
	;
	LDY incidx1	; correcting perspective
	LDA perspc_width,y	; with LUT
	AND #1
	BEQ skip3
	INC scroidx
skip3	INC incidx1
	LDY incidx2	; streching vertically
	LDA perspc_width,y	; with LUT
	AND #2
	BEQ skip4
	INC tempvar
skip4	INC incidx2
	LDX incidx2
	CPX #25		; repeat 25 times
	BNE loop4
	LDY #40		; delay
loop5	LDX #255
loop6	DEX
	BNE loop6
	DEY
	BNE loop5
	INC scroptr	; scroll length: 72 "pixel" columns
	LDA scroptr
	CMP #72
	BNE loop3
	LDA #0
	STA scroptr
	JMP loop3
	;
byt2dw	LDA textdat,y	; depacker
	STA dstptrl
	LDX #4
loopa1	LDA #0
	ASL dstptrl
	ROL A
	ASL dstptrl
	ROL A
store	STA dest
	LDA store+1
	INC store+1
	BNE skipa1
	INC store+2
skipa1	DEX
	BNE loopa1
	RTS
	;
copydat LDA store+1	; duplicator
	STA copy+1
	LDA store+2
	STA copy+2
src	LDA dest
copy	STA $ffff
	INC src+1
	BNE skipb1
	INC src+2
skipb1	INC copy+1
	BNE skipb2
	INC copy+2
skipb2	LDA src+1
	CMP store+1
	BNE src
	LDA src+2
	CMP store+2
	BNE src
	RTS
	;
bresenh	LDA tempvar	; strecher fashioned after the Bresenham line algorithm
	ASL A
	CLC
	ADC #7
	STA DELTAX
	LSR A
	STA ERROR
	LDA #7
	STA DELTAY
	LDY #0
	STY X0
	STY Y0
loopc1	LDY Y0
	LDA (srcptrl),y
	TAX
	LDA textcls,x
	LDY X0
	STA (dstptrl),y
	LDA ERROR
	SEC
	SBC DELTAY
	STA ERROR
	BPL skipc1
	INC Y0
	LDA ERROR
	CLC
	ADC DELTAX
	STA ERROR
skipc1	INC X0
	LDA X0
	CMP DELTAX
	BNE loopc1
	RTS
	;
	; even more text for Exin :)
	; packed text data as indexes
textidx	DB  7,  1,  0,  2,  0,  3,  4,  5,  4,  5,  0,  2,  0 , 6,  6,  7,  6,  6,  0,  7,  8,  8
	DB  9,  9,  0,  7,  9,  9,  9, 10,  0, 11, 12, 12, 13, 14,  0,  0, 15, 16, 16, 17, 17, 18
	DB  0, 11, 12, 12, 13, 14,  0, 19, 20, 20, 20, 21,  0, 22, 23, 24,  7, 25,  0,  0, 26, 27
	DB 28, 29, 28, 27, 26,  0
	;
	; packed text data indexed chunks
textdat	DB $00, $00
	DB $40, $00
	DB $55, $10
	DB $55, $00
	DB $01, $00
	DB $54, $00
	DB $00, $04
	DB $55, $54
	DB $41, $04
	DB $40, $04
	DB $15, $50
	DB $a0, $20
	DB $88, $08
	DB $82, $08
	DB $80, $a0
	DB $3f, $f0
	DB $c0, $0c
	DB $28, $f0
	DB $20, $30
	DB $3f, $f0
	DB $f3, $0c
	DB $3c, $30
	DB $05, $00
	DB $04, $50
	DB $04, $04
	DB $04, $00
	DB $05, $40
	DB $10, $10
	DB $44, $04
	DB $41, $51
	;
;	DB 0, 0, 1, 1, 1, 0, 0, 0
;	DB 0, 1, 0, 0, 0, 1, 0, 0
;	DB 1, 0, 1, 0, 0, 0, 1, 0
;	DB 1, 0, 0, 1, 1, 1, 1, 0
;	DB 1, 0, 1, 0, 0, 0, 1, 0
;	DB 0, 1, 0, 0, 0, 1, 0, 0
;	DB 0, 0, 1, 1, 1, 0, 0, 0
	;
	; displayed colours
textcls	DB $10, $71, $32, $16
	;
	; LUT for perspective correction, vertical streching and row address calculation
	;
perspc_width
	DB 3, 1, 2, 3
	DB 0, 3, 2, 1
	DB 2, 2, 0, 3
	DB 2, 0, 2, 3
	DB 0, 2, 2, 1
	DB 2, 2, 0, 2
	DB 3
